// Generated by rstantools.  Do not edit by hand.

/*
    This file is part of rstanarm.
    Copyright (C) 2015, 2016 Trustees of Columbia University
    
    rstanarm is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    rstanarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with rstanarm.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_zinb_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 25> locations_array__ =
  {" (found before start of program)",
  " (in 'zinb', line 7, column 2 to column 22)",
  " (in 'zinb', line 8, column 2 to column 19)",
  " (in 'zinb', line 9, column 2 to column 29)",
  " (in 'zinb', line 10, column 2 to column 28)",
  " (in 'zinb', line 13, column 2 to column 23)",
  " (in 'zinb', line 15, column 4 to column 29)",
  " (in 'zinb', line 14, column 16 to line 16, column 3)",
  " (in 'zinb', line 14, column 2 to line 16, column 3)",
  " (in 'zinb', line 19, column 2 to column 22)",
  " (in 'zinb', line 20, column 2 to column 23)",
  " (in 'zinb', line 21, column 2 to column 18)",
  " (in 'zinb', line 22, column 2 to column 31)",
  " (in 'zinb', line 27, column 6 to column 80)",
  " (in 'zinb', line 25, column 6 to column 117)",
  " (in 'zinb', line 24, column 4 to line 27, column 80)",
  " (in 'zinb', line 23, column 17 to line 28, column 3)",
  " (in 'zinb', line 23, column 2 to line 28, column 3)",
  " (in 'zinb', line 2, column 2 to column 8)",
  " (in 'zinb', line 3, column 8 to column 9)",
  " (in 'zinb', line 3, column 2 to column 24)",
  " (in 'zinb', line 4, column 8 to column 9)",
  " (in 'zinb', line 4, column 2 to column 19)",
  " (in 'zinb', line 9, column 8 to column 9)",
  " (in 'zinb', line 13, column 8 to column 9)"};
#include <stan_meta_header.hpp>
class model_zinb final : public model_base_crtp<model_zinb> {
private:
  int J;
  std::vector<int> ystarraw;
  std::vector<double> CF;
public:
  ~model_zinb() {}
  model_zinb(stan::io::var_context& context__, unsigned int
             random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_zinb_namespace::model_zinb";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 18;
      context__.validate_dims("data initialization", "J", "int",
        std::vector<size_t>{});
      J = std::numeric_limits<int>::min();
      current_statement__ = 18;
      J = context__.vals_i("J")[(1 - 1)];
      current_statement__ = 19;
      stan::math::validate_non_negative_index("ystarraw", "J", J);
      current_statement__ = 20;
      context__.validate_dims("data initialization", "ystarraw", "int",
        std::vector<size_t>{static_cast<size_t>(J)});
      ystarraw = std::vector<int>(J, std::numeric_limits<int>::min());
      current_statement__ = 20;
      ystarraw = context__.vals_i("ystarraw");
      current_statement__ = 21;
      stan::math::validate_non_negative_index("CF", "J", J);
      current_statement__ = 22;
      context__.validate_dims("data initialization", "CF", "double",
        std::vector<size_t>{static_cast<size_t>(J)});
      CF = std::vector<double>(J, std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 22;
      CF = context__.vals_r("CF");
      current_statement__ = 23;
      stan::math::validate_non_negative_index("mui", "J", J);
      current_statement__ = 24;
      stan::math::validate_non_negative_index("lambda", "J", J);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = 1 + 1 + J + 1;
  }
  inline std::string model_name() const final {
    return "model_zinb";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_zinb_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      local_scalar_t__ kappa = DUMMY_VAR__;
      current_statement__ = 1;
      kappa = in__.template read_constrain_lb<local_scalar_t__,
                jacobian__>(0, lp__);
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 2;
      mu = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      std::vector<local_scalar_t__> mui =
        std::vector<local_scalar_t__>(J, DUMMY_VAR__);
      current_statement__ = 3;
      mui = in__.template read_constrain_lb<std::vector<local_scalar_t__>,
              jacobian__>(0, lp__, J);
      local_scalar_t__ phi = DUMMY_VAR__;
      current_statement__ = 4;
      phi = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(0,
              1, lp__);
      std::vector<local_scalar_t__> lambda =
        std::vector<local_scalar_t__>(J, DUMMY_VAR__);
      current_statement__ = 8;
      for (int i = 1; i <= J; ++i) {
        current_statement__ = 6;
        stan::model::assign(lambda,
          (stan::model::rvalue(mui, "mui", stan::model::index_uni(i)) /
          stan::model::rvalue(CF, "CF", stan::model::index_uni(i))),
          "assigning variable lambda", stan::model::index_uni(i));
      }
      {
        current_statement__ = 9;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(mu, 1, 0.001));
        current_statement__ = 10;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(kappa, 1, 0.7));
        current_statement__ = 11;
        lp_accum__.add(stan::math::beta_lpdf<propto__>(phi, 1, 1));
        current_statement__ = 12;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(mui, kappa, (kappa /
                         mu)));
        current_statement__ = 17;
        for (int n = 1; n <= J; ++n) {
          current_statement__ = 15;
          if (stan::math::logical_eq(
                stan::model::rvalue(ystarraw, "ystarraw",
                  stan::model::index_uni(n)), 0)) {
            current_statement__ = 14;
            lp_accum__.add(stan::math::log_sum_exp(
                             stan::math::bernoulli_lpmf<false>(1, phi),
                             (stan::math::bernoulli_lpmf<false>(0, phi) +
                             stan::math::poisson_lpmf<false>(
                               stan::model::rvalue(ystarraw, "ystarraw",
                                 stan::model::index_uni(n)),
                               stan::model::rvalue(lambda, "lambda",
                                 stan::model::index_uni(n))))));
          } else {
            current_statement__ = 13;
            lp_accum__.add((stan::math::bernoulli_lpmf<false>(0, phi) +
              stan::math::poisson_lpmf<false>(
                stan::model::rvalue(ystarraw, "ystarraw",
                  stan::model::index_uni(n)),
                stan::model::rvalue(lambda, "lambda",
                  stan::model::index_uni(n)))));
          }
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_zinb_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      double kappa = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 1;
      kappa = in__.template read_constrain_lb<local_scalar_t__,
                jacobian__>(0, lp__);
      double mu = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 2;
      mu = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      std::vector<double> mui =
        std::vector<double>(J, std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 3;
      mui = in__.template read_constrain_lb<std::vector<local_scalar_t__>,
              jacobian__>(0, lp__, J);
      double phi = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 4;
      phi = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(0,
              1, lp__);
      std::vector<double> lambda =
        std::vector<double>(J, std::numeric_limits<double>::quiet_NaN());
      out__.write(kappa);
      out__.write(mu);
      out__.write(mui);
      out__.write(phi);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 8;
      for (int i = 1; i <= J; ++i) {
        current_statement__ = 6;
        stan::model::assign(lambda,
          (stan::model::rvalue(mui, "mui", stan::model::index_uni(i)) /
          stan::model::rvalue(CF, "CF", stan::model::index_uni(i))),
          "assigning variable lambda", stan::model::index_uni(i));
      }
      if (emit_transformed_parameters__) {
        out__.write(lambda);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ kappa = DUMMY_VAR__;
      current_statement__ = 1;
      kappa = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, kappa);
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 2;
      mu = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, mu);
      std::vector<local_scalar_t__> mui =
        std::vector<local_scalar_t__>(J, DUMMY_VAR__);
      current_statement__ = 3;
      stan::model::assign(mui, in__.read<std::vector<local_scalar_t__>>(J),
        "assigning variable mui");
      out__.write_free_lb(0, mui);
      local_scalar_t__ phi = DUMMY_VAR__;
      current_statement__ = 4;
      phi = in__.read<local_scalar_t__>();
      out__.write_free_lub(0, 1, phi);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "kappa", "double",
        std::vector<size_t>{});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "mu", "double",
        std::vector<size_t>{});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "mui", "double",
        std::vector<size_t>{static_cast<size_t>(J)});
      current_statement__ = 4;
      context__.validate_dims("parameter initialization", "phi", "double",
        std::vector<size_t>{});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ kappa = DUMMY_VAR__;
      current_statement__ = 1;
      kappa = context__.vals_r("kappa")[(1 - 1)];
      out__.write_free_lb(0, kappa);
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 2;
      mu = context__.vals_r("mu")[(1 - 1)];
      out__.write_free_lb(0, mu);
      std::vector<local_scalar_t__> mui =
        std::vector<local_scalar_t__>(J, DUMMY_VAR__);
      current_statement__ = 3;
      mui = context__.vals_r("mui");
      out__.write_free_lb(0, mui);
      local_scalar_t__ phi = DUMMY_VAR__;
      current_statement__ = 4;
      phi = context__.vals_r("phi")[(1 - 1)];
      out__.write_free_lub(0, 1, phi);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"kappa", "mu", "mui", "phi"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"lambda"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{},
                std::vector<size_t>{},
                std::vector<size_t>{static_cast<size_t>(J)},
                std::vector<size_t>{}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(J)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "kappa");
    param_names__.emplace_back(std::string() + "mu");
    for (int sym1__ = 1; sym1__ <= J; ++sym1__) {
      param_names__.emplace_back(std::string() + "mui" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "phi");
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= J; ++sym1__) {
        param_names__.emplace_back(std::string() + "lambda" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "kappa");
    param_names__.emplace_back(std::string() + "mu");
    for (int sym1__ = 1; sym1__ <= J; ++sym1__) {
      param_names__.emplace_back(std::string() + "mui" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "phi");
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= J; ++sym1__) {
        param_names__.emplace_back(std::string() + "lambda" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"kappa\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mui\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(J) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"parameters\"},{\"name\":\"phi\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"lambda\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(J) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"transformed_parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"kappa\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mui\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(J) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"parameters\"},{\"name\":\"phi\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"lambda\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(J) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"transformed_parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((1 + 1) + J) + 1);
    const size_t num_transformed = emit_transformed_parameters * (J);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((1 + 1) + J) + 1);
    const size_t num_transformed = emit_transformed_parameters * (J);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_zinb_namespace::model_zinb;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_zinb_namespace::profiles__;
}
#endif
#endif
